EDIT - bug #5691

Referencing objects view makes editor inresponsive if an object references many objects

04/08/2016 03:19 PM - Andreas Miller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 8:00 hours
Target version: Release 4.6

Severity: major Found in Version:

Description

If the referencing objects view is switched on and an object gets the focus which is referenced very often (e.g. secundum references

or Linné/L.) the TaxEditor does not react anymore but shows an hourglass instead.

This should not happen as the referencing objects view should run in a separate thread not influencing the performance of the editor.

For very large sets the Editor may even crash.

Related issues:
Precedes EDIT - bug #6418: Status line does not update after completing the u... Worksforme

Associated revisions

Revision dda1d525 - 02/08/2017 03:34 PM - Katja Luther

ref #5691: fix the problem that ref. objects view does not has its own thread

Revision 30846ae3 - 02/15/2017 11:25 AM - Katja Luther
ref #5691: minor

Revision 61b8e368 - 02/17/2017 10:57 AM - Katja Luther

ref #5691: move description setting to an own thread in referencing objects view

Revision 48418526 - 03/07/2017 10:59 AM - Patrick Plitzner

ref #5691 Only have on update job at a time for ReferencingObjectsView

Revision f8485a00 - 03/07/2017 03:28 PM - Katja Luther

ref #5691: avoid invalid thread access in referencing object view by calling updateContentDescription in an extra job

Revision cd19940f - 03/09/2017 12:16 PM - Katja Luther

fix details view for authorship cache and referencing objects view

Revision 6463610 - 03/09/2017 03:53 PM - Katja Luther

fix problem when description of an element is null in referencing objects view

History

#1 - 09/02/2016 03:06 PM - Andreas Miiller
- Description updated
- Priority changed from New to Highest

#2 - 10/05/2016 12:11 PM - Andreas Miuller

Maybe the problem is the label provider which initializes lazy objects. Which thread does it use?

#3 - 10/05/2016 12:19 PM - Andreas Miiller
- Target version changed from Unassigned CDM tickets to Release 4.4

- Estimated time set to 8:00 h
Or even better solution, use DTOs on server side.

#4 - 12/01/2016 02:45 PM - Andreas Miiller

- Target version changed from Release 4.4 to Release 4.5

#5 - 01/19/2017 01:32 PM - Andreas Miiller

- Target version changed from Release 4.5 to Release 4.6

#6 - 02/14/2017 08:15 AM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

The problem of unresponsible editor is solved but the status line keeps the message "Updating referencing objects view...", this needs to be solved.
@AM could you please review the main topic of this ticket, | will create a new ticket for the status line subject.

#7 - 02/14/2017 08:18 AM - Katja Luther

- Precedes bug #6418: Status line does not update after completing the update of the referencing objects view added

#8 - 02/16/2017 10:48 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

| got an "Invalid thread access" exception when testing it for reference "The International Plant Names Index (2012)..." on edit_test/rem_conf_am (for
some reason the log does not show the server information - maybe also a bug?).

Second time it worked.

login

editor version : 4.6.0.201702161652

server : ()

schema version

os : Windows Server 2012 R2 6.3 amd64

java : 1.8.0_121
org.eclipse.swt.SWTException: Invalid thread

access

at org.eclipse.swt.SWT.error (SWT. java:4282)

at org.eclipse.swt.SWT.error (SWT. java:4197)

at org.eclipse.swt.SWT.error (SWT. java:4168)

at org.eclipse.swt.widgets.Widget.error (Widget.java:468)

at org.eclipse.swt.widgets.Widget.checkWidget (Widget.java:359)
at org.eclipse.swt.widgets.Widget.getData (Widget. java:525)

at org.eclipse.ui.internal.presentations.

:186)

at org.eclipse.ui.internal.presentations.

va:238)

at org.eclipse.ui.internal.presentations.
at org.eclipse.ui.internal.presentations.
at org.eclipse.ui.internal.presentations.

lder. java:304)

at org.eclipse.ui.internal.presentations.

3)

at org.eclipse.ui.internal.presentations.

r.java:83)

at org.eclipse.ui.internal.presentations.
at org.eclipse.ui.internal.presentations.

defaultpresentation.DefaultTabFolder.getTab (DefaultTabFolder. java
defaultpresentation.DefaultTabFolder.getItems (DefaultTabFolder. ja
util.AbstractTabFolder.findItem (AbstractTabFolder.java:171)

util.PresentablePartFolder.getTab (PresentablePartFolder. java:375)
util.PresentablePartFolder.childPropertyChanged (PresentablePartFo
util.PresentablePartFolder.access$2 (PresentablePartFolder. java:30

util.PresentablePartFolder$3.propertyChanged (PresentablePartFolde

PresentablePart.firePropertyChange (PresentablePart. java:137)
PresentablePart$l.propertyChanged (PresentablePart. java:97)

at org.eclipse.ui.internal.PartPane.firePropertyChange (PartPane. java:620)

at org.eclipse.ui.internal.PartPane.propertyChanged (PartPane.java:625)
at org.eclipse.ui.internal.WorkbenchPartReference.immediateFirePropertyChange (WorkbenchPartReference. java:

571)

at org.eclipse.ui.internal.WorkbenchPartReference.firePropertyChange (WorkbenchPartReference. java:564)

at org.eclipse.ui.internal.WorkbenchPartReference.deferEvents (WorkbenchPartReference. java:219)

at org.eclipse.ui.internal.WorkbenchPartReference.refreshFromPart (WorkbenchPartReference. java:328)

at org.eclipse.ui.internal.WorkbenchPartReference.partPropertyChanged (WorkbenchPartReference. java:296)

at org.eclipse.ui.internal.WorkbenchPartReference$2.propertyChanged (WorkbenchPartReference. java:181)

at org.eclipse.ui.part.WorkbenchPart.firePropertyChange (WorkbenchPart. java:129)

at org.eclipse.ui.part.WorkbenchPart.internalSetContentDescription (WorkbenchPart.java:451)

at org.eclipse.ui.part.WorkbenchPart.setContentDescription (WorkbenchPart.java:437)

at org.eclipse.ui.part.ViewPart.setContentDescription (ViewPart. java:154)

at eu.etaxonomy.taxeditor.bulkeditor.referencingobjects.ReferencingObjectsView.getReferencingObjects (Refer

encingObjectsView. java:336)
at eu.etaxonomy.taxeditor.bulkeditor.referencingobjects.ReferencingObjectsView.access$3 (ReferencingObjects
View. java:273)

at eu.etaxonomy.taxeditor.bulkeditor.referencingobjects.ReferencingObjectsView$2.run(ReferencingObjectsVie
w.java:214)

at org.eclipse.core.internal. jobs.Worker.run (Worker. java:54)

#9 - 02/16/2017 10:58 PM - Andreas Miuller

when canceling the job it looks like it sometimes still shows the old records (for an old selection) this may be misleading. We should always empty the
view (best before the job starts to make immediately clear that the selection has changed and the view does not represent the selections referencing
objects anymore.

Also when the job is canceled we should somehow note that it was canceled and if any records are shown they may not be complete. By the way it
would be nice to have a count saying how many records are there in total. Something like "xxx is referenced 3454 times:" (maybe a new ticket? But
cdmlib functionality already exists for this | think)

#10 - 02/16/2017 11:04 PM - Andreas Miiller

The above exceptions appears often though not 100% reproducable.

Also when a new object is selected the dialog does not immediately go away, though the ref objects view response quite fast.

#11 - 02/17/2017 10:45 AM - Katja Luther

moved the setting of the description to its own thread to avoid the "Invalid thread access" exception. And clear right after the selection changed.

#12 - 03/02/2017 11:55 AM - Andreas Muller

Invalid thread access still exists. Happened when editing specimen data in specimen editor.

login
editor version : 4.6.0.201702272351
server : ()
schema version
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
org.eclipse.swt.SWIException: Invalid thread access

at org.eclipse.swt.SWT.error (SWT. java:4282)

at org.eclipse.swt.SWT.error (SWT.java:4197)

at org.eclipse.swt.SWT.error (SWT.java:4168)

at org.eclipse.swt.widgets.Widget.error (Widget.java:468)

at org.eclipse.swt.widgets.Widget.checkWidget (Widget.java:359)

at org.eclipse.swt.widgets.Widget.getData (Widget.java:525)

at org.eclipse.ui.internal.presentations.defaultpresentation.DefaultTabFolder.getTab (DefaultTabFolder. java
:186)

at org.eclipse.ui.internal.presentations.defaultpresentation.DefaultTabFolder.getItems (DefaultTabFolder. ja
va:238)

at org.eclipse.ui.internal.presentations.util.AbstractTabFolder.findItem (AbstractTabFolder. java:171)

at org.eclipse.ui.internal.presentations.util.PresentablePartFolder.getTab (PresentablePartFolder. java:375)

at org.eclipse.ui.internal.presentations.util.PresentablePartFolder.childPropertyChanged (PresentablePartFo
lder. java:304)

at org.eclipse.ui.internal.presentations.util.PresentablePartFolder.access$2 (PresentablePartFolder. java:30
3)

at org.eclipse.ui.internal.presentations.util.PresentablePartFolder$3.propertyChanged (PresentablePartFolde
r.java:83)

at org.eclipse.ui.internal.presentations.PresentablePart.firePropertyChange (PresentablePart. java:137)

at org.eclipse.ui.internal.presentations.PresentablePart$l.propertyChanged (PresentablePart. java:97)

at org.eclipse.ui.internal.PartPane.firePropertyChange (PartPane. java:620)

at org.eclipse.ui.internal.PartPane.propertyChanged (PartPane. java:625)

at org.eclipse.ui.internal.WorkbenchPartReference.immediateFirePropertyChange (WorkbenchPartReference. java:
571)

at org.eclipse.ui.internal.WorkbenchPartReference.firePropertyChange (WorkbenchPartReference.java:564)

at org.eclipse.ui.internal.WorkbenchPartReference.deferEvents (WorkbenchPartReference. java:219)

at org.eclipse.ui.internal.WorkbenchPartReference.refreshFromPart (WorkbenchPartReference. java:328)

at org.eclipse.ui.internal.WorkbenchPartReference.partPropertyChanged (WorkbenchPartReference. java:296)

at org.eclipse.ui.internal.WorkbenchPartReference$2.propertyChanged (WorkbenchPartReference. java:181)

at org.eclipse.ui.part.WorkbenchPart.firePropertyChange (WorkbenchPart. java:129)

at org.eclipse.ui.part.WorkbenchPart.setTitle (WorkbenchPart. java:311)

at org.eclipse.ui.part.WorkbenchPart.setDefaultTitle (WorkbenchPart.java:404)

at org.eclipse.uil.part.WorkbenchPart.setContentDescription (WorkbenchPart. java:439)

at org.eclipse.ui.part.ViewPart.setContentDescription (ViewPart. java:154)

at eu.etaxonomy.taxeditor.bulkeditor.referencingobjects.ReferencingObjectsView.getReferencingObjects (Refer
encingObjectsView. java:336)

at eu.etaxonomy.taxeditor.bulkeditor.referencingobjects.ReferencingObjectsView.access$3 (ReferencingObjects
View. java:273)
at eu.etaxonomy.taxeditor.bulkeditor.referencingobjects.ReferencingObjectsView$2.run (ReferencingObjectsVie
w.java:214)
at org.eclipse.core.internal. jobs.Worker.run (Worker.java:54)

#13 - 03/07/2017 01:38 PM - Katja Luther

- Status changed from Feedback to Resolved

please check whether the exception occurs again.

#14 - 03/07/2017 01:38 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

#15 - 03/07/2017 03:02 PM - Andreas Miiller

Unfortunately it still exists. | opened my test database rem_conf_am on edit_test and opened taxon Abies testus nothosubsp. uppltj V.V.Petrovsky in
classification Testklass after opening the view => there it immediately came.
.PresentablePartFolder$3.propertyChanged (PresentablePartFolde

.PresentablePart.firePropertyChange (PresentablePart. java:137)
.PresentablePart$l.propertyChanged (PresentablePart. java:97)
PartPane.propertyChanged (PartPane. java: 625)
firePropertyChange (WorkbenchPart. java:129)
setTitle (WorkbenchPart.java:311)
setDefaultTitle (WorkbenchPart. java:404)
setContentDescription (WorkbenchPart.java:439)

eu.etaxonomy.taxeditor.bulkeditor.referencingobjects.ReferencingObjectsView.getReferencingObjects (Refer

at eu.etaxonomy.taxeditor.bulkeditor.referencingobjects.ReferencingObjectsView.access$3 (ReferencingObjects
View. java:282)
at eu.etaxonomy.taxeditor.bulkeditor.referencingobjects.ReferencingObjectsView$2.run (ReferencingObjectsVie

w.Jjava:223)
at org.eclipse.core.internal. jobs.Worker.run (Worker. java:54)

#16 - 03/07/2017 03:02 PM - Andreas Miiller

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther
#17 - 03/10/2017 09:18 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

with the last commits it should work now

#18 - 03/10/2017 09:52 AM - Andreas Miiller
- Status changed from Resolved to Closed

- Assignee changed from Andreas Miller to Katja Luther

Yes we close this ticket now, the View really works MUCH better now.
Anyway, could you still adapt the label provider to never return null,

#19 - 03/11/2017 10:52 PM - Andreas Miiller
- % Done changed from 0 to 100

- Private changed from Yes to No
